#include "opengl.h"

/* Rsolution de la fentre OpenGL		*/
int format[4][2]	= {	{1280,1024},	
						{1024, 768},
						{800, 600},
						{640, 480}};


void Idle(void)
{
#if VIDEO
	IplImage *tmp;
	/* Capture LEFT*/
	tmp = cvQueryFrame( captureL );
	/* Retournement de l'image */
	cvFlip(tmp,tmp,0);
	/* Cration des images et redimensionnement */
	image[LEFT0].img = cvCreateImage(cvSize(tmp->width*factor,tmp->height*factor),tmp->depth,tmp->nChannels);
	image[LEFT1].img = cvCreateImage(cvSize(tmp->width*factor,tmp->height*factor),tmp->depth,tmp->nChannels);
	cvResize(tmp,image[LEFT0].img,CV_INTER_NN);
	cvResize(tmp,image[LEFT1].img,CV_INTER_NN);

	/* Capture RIGHT */
	tmp = cvQueryFrame( captureR );
	/* Retournement de l'image */
	cvFlip(tmp,tmp,0);
	/* Cration des images et redimensionnement */
	image[RIGHT0].img = cvCreateImage(cvSize(tmp->width*factor,tmp->height*factor),tmp->depth,tmp->nChannels);
	image[RIGHT1].img = cvCreateImage(cvSize(tmp->width*factor,tmp->height*factor),tmp->depth,tmp->nChannels);
	cvResize(tmp,image[RIGHT0].img,CV_INTER_NN);
	cvResize(tmp,image[RIGHT1].img,CV_INTER_NN);

	/* Lancement des calculs */
	TrackProcess(Trackmode);
	glutSetWindow(Handle_Tracking );
	glutPostRedisplay();
	glutSetWindow(Handle_Scanline);
	glutPostRedisplay();
	glutSetWindow(Handle_Redressement);
	glutPostRedisplay();
#endif
}
/* Affichage d'un texte */
void Write(int x,int y,char *buffer,void* font)
{
	int i;
	/* Positionnement du curseur */
	glRasterPos2f(x,y);
	/* Affichage lettre/lettre */
	for(i=0;i<(int)strlen(buffer);i++)
		glutBitmapCharacter(font,buffer[i]);
}
/* Affichage de la bordure */
void displayTexte()
{
	char buffer[64];
	/* Dimension de l'image */
	glColor3f(1,1,1);
	Write(0,47,"Dimensions",GLUT_BITMAP_HELVETICA_12);
	sprintf(buffer,"%d x %d",Width,Height);
	Write(0,45,buffer,GLUT_BITMAP_HELVETICA_12);
	/* Coordonnees souris */
	glColor3f(1,1,1);
	Write(0,42,"Souris",GLUT_BITMAP_HELVETICA_12);
	if(!Full)
		sprintf(buffer,"%d %d\n",Width*(mouse_trackx%((TailleXtrack-bordure)/2))/((TailleXtrack-bordure)/2),
								 Height*(mouse_tracky%(TailleYtrack/2))/(TailleYtrack/2));
	else
		sprintf(buffer,"%d %d\n",Width*(mouse_trackx%(TailleXtrack-bordure))/(TailleXtrack-bordure),
								 Height*(mouse_tracky%(TailleYtrack))/(TailleYtrack));

	Write(0,40,buffer,GLUT_BITMAP_HELVETICA_12);
	/* Nombre de points tracks */
	sprintf(buffer,"Points: %d",nbpoints);
	Write(0,37,buffer,GLUT_BITMAP_HELVETICA_12);
	/* Version du suivi */
	Write(0,34,"Tracking:",GLUT_BITMAP_HELVETICA_12);
	sprintf(buffer,"Version%d",Trackmode);
	Write(0,32,buffer,GLUT_BITMAP_HELVETICA_12);
}

/* Affichage d'une image et des points tracks */
void displayImage(IplImage *img,int posx,int posy,int taillex,int tailley, double zoomx,double zoomy,
				  Tracker *track,CvPoint3D64d *score,
				  	CvPoint2D64d *scanline, int	nbscanline)
{
	int i;
	char buffer[64];
	GLUquadricObj 	* quad;
	static IplImage *res;
	double coef=0;
	if(!img)
		return;
	/* Retournement de l'image initiale */
	if(!res)
		res = cvCreateImage(cvSize(img->width,img->height),img->depth,img->nChannels);
	cvFlip(img,res,0);
	/* Affectation du zoom */
	glPixelZoom (zoomx,zoomy);	
	/* Placement du curseur */
	glRasterPos2i(posx, posy);
	/* Affichage de l'image */
	glDrawPixels(res->width, res->height, GL_BGR_EXT,GL_UNSIGNED_BYTE, res->imageData);
	/* Affichage des points (avec id)*/
	glLineWidth(2);
	/* Affichage des points s'ils sont suivis */
	quad = gluNewQuadric();
	gluQuadricDrawStyle (quad, GLU_SILHOUETTE);  
	if(track)
	for(i=0;i<track->count;i++)
	{
		glColor3f(1,0,0);
		// Verification du status

		if(score && score[i].z!=-1)
			glColor3f(1,0,0);					/* Point perdu */
		else
			glColor3f(0,0,1);					/* Point suivi */
		// Verification du score
		if(score && score[i].z > 1)
		{
			if(score[i].z <= (seuil+1) )
			{
				coef = (score[i].z-1.)/(seuil);
				glColor3f(1,0,coef);			/* premier critere de score (rouge->violet) */
			}
			else
			{
				coef = (score[i].z-1 )/(2*seuil);
				glColor3f(coef,1,0);			/* second critere de score (jaune->vert) */
			}
			gluQuadricDrawStyle (quad, GLU_FILL);  
		}
		else
			gluQuadricDrawStyle (quad, GLU_SILHOUETTE); 
		/* Affichage du cercle */
		glPushMatrix();
		glTranslatef(track->point[i].x*(taillex)/res->width+posx,(res->height-track->point[i].y)*(tailley)/res->height+posy,0);
		gluDisk(quad,0.5,5,30,1);
		glPopMatrix();
		/* Affichage du n */
		if(id)
		{
			sprintf(buffer,"%d",i);
			glColor3f(0,1,0);
			Write((int)track->point[i].x*(taillex)/res->width+posx-3,(int)(res->height-track->point[i].y)*(tailley)/res->height+posy+6, buffer, GLUT_BITMAP_HELVETICA_18);
		}
	}
	glLineWidth(1);
	/* Affichage des scanlines */
	if(scanline)
	{
		glColor3f(0,0,1);
		for(i=0;i<nbscanline;i+=10)
		{
			glBegin(GL_LINE_STRIP);
				glVertex2f(scanline[i].x*taillex/Width+posx, (Height-scanline[i].y)*tailley/Height+posy);
				glVertex2f(scanline[i+1].x*taillex/Width+posx, (Height-scanline[i+1].y)*tailley/Height+posy);
			glEnd();
		}
	}
	/* Affichage des points en fonction de leur score */
	cvReleaseImage(&res);
}
/* Affichage des images */
void displayScene(void)
{
	int i;
	double zoomx,zoomy;
	int place[4][2]={	{0,TailleYtrack/2},					// Haut droit
						{TailleXtrack/2,TailleYtrack/2},	// Haut gauche
						{0,0},								// Bas droit
						{TailleXtrack/2,0}					// Bas gauche
					};
	/* Initialisation du frame buffer */
	glClearColor(0,0,0.0,0);
	glClear (GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	/* Gestion du zoom */
	zoomx = ((TailleXtrack-bordure)/(2.*(Full==0 ? 1.:0.5)))/(GLfloat )Width;
	zoomy = (TailleYtrack/(2*(Full==0 ? 1:0.5)))/(GLfloat )Height;

	if(Full)
		displayImage(image[Full-1].img,place[2][X],place[2][Y],TailleXtrack,TailleYtrack,zoomx,zoomy,image[Full-1].tracker,image[Full-1].score,NULL,0);
	else
		for(i=0;i<4;i++)
			displayImage(image[i].img,place[i][X],place[i][Y],TailleXtrack/2,TailleYtrack/2,zoomx,zoomy,image[i].tracker,image[i].score,NULL,0);

} 
/* Affichage de la scne */
void display(void)
{
	/* Portion active de la fentre */
	glViewport(0,0,TailleXtrack-bordure,TailleYtrack);
	/* Initialisation des matrices */
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	/* Dfinition du monde */
	glOrtho(0,TailleXtrack,0,TailleYtrack,-5,5);	
	displayScene();
	/* Portion active de la fentre */
	glViewport(TailleXtrack-bordure,0,TailleXtrack,TailleYtrack);
	/* Initialisation des matrices */
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	/* Dfinition du monde */
	glOrtho(-0,10,-50,50,-10,10);	
	displayTexte();
	/* Affichage du frame buffer */
	glutSwapBuffers();
}
/* Redimensionnement de l'application */
void reshape(GLsizei w, GLsizei h)
{
	TailleXtrack = w;
	TailleYtrack = h;
	/* Affichage des images */
	display();
}
void mouse(int b,int s,int x,int y)
{
	static int indic=0;		// = 0, normal		=1, plein ecran
	if( b != GLUT_RIGHT_BUTTON  || s != GLUT_DOWN)
		return;
	if( indic)
		Full=0;
	else
	{
		/* n de l'image  agrandir */
		if( (x < TailleXtrack/2) && (y < TailleYtrack/2))
			Full = 1;
		if( (x < TailleXtrack/2) && (y > TailleYtrack/2))
			Full = 3;
		if( (x > TailleXtrack/2) && (y > TailleYtrack/2))
			Full = 4 ;
		if( (x > TailleXtrack/2) && (y < TailleYtrack/2))
			Full = 2;
	}
	indic=!indic;
	glutPostRedisplay();
}
/* Gestion mouvements souris (avec actions) */
void mouseMove(int x,int y)
{
}
/* Gestion mouvements de la souris (sans actions) */
void mousePassiveMotion(int x,int y)
{
	/* Recuperation coordonnees souris */
	mouse_trackx = x;
	mouse_tracky = y;
	glutPostRedisplay();
}
/* Gestion evenements clavier */
void clavier(unsigned char key, int x, int y)
{
//	IplImage *r1,*r2;
	int i,j;
	switch(key)
	{
		/* Sorite de l'appli */
		case 27:
			exit(0);
		/* Affichage des id des points */
		case 'I':
		case 'i':
			id=!id;
			glutSetWindow(Handle_Tracking );
			glutPostRedisplay();
		break;
		/* Affichage d'informations */
		case 'a':
		case 'A':
		{
			FILE *file;
			if(!Debug)
				file = fopen("affichage.txt","w");
			else
				file = stderr;

			fprintf(file,"Affichages des coordonnees des points :\n");
			fprintf(file,"---------------------------------------\n");
			fprintf(file,"\t id\t X\t Y\t status\t score\n");
			for(i=0;i<4;i++)
			{
				fprintf(file,"image %d:\n",i);
				for(j=0;j<image[i].tracker->count;j++)
				{
					fprintf(file,"\t %d\t %.2f\t %.2f\t %.2f\t",j,image[i].tracker->point[j].x,image[i].tracker->point[j].y,image[i].score[j].z);
//					if(image[i].score)
//						printf(" %f",image[i].score[j].z);
					fprintf(file,"\n");
				}
			}
			fprintf(file,"Affichage des couples :\n");
			fprintf(file,"-----------------------\n");
			fprintf(file,"\t Couple gauche\t Couple droit\t score\n");
			for(i=0;i<4;i++)
			{
				if(image[i].score)
				{
					fprintf(file,"image %d\n",i);
					for(j=0;j<image[i].tracker->count;j++)
					{
						if(image[i].score[j].z >= (seuil*2+1) )
						{
							fprintf(file,"(%d)\t %g\t\t %g\t\t %g\t",j,image[i].score[j].x,image[i].score[j].y,image[i].score[j].z);
							fprintf(file,"%.2f %.2f   %.2f %.2f\n",image[i].tracker->point[(int)image[i].score[j].x].x,image[i].tracker->point[(int)image[i].score[j].x].y,
													  image[i].tracker->point[(int)image[i].score[j].y].x,image[i].tracker->point[(int)image[i].score[j].y].y);
							fprintf(file,"\n");
						}
					}
				}
			}
			break;
		}
		/* Point trackes +1 */
		case '+':
			nbpoints++;
			if(nbpoints==12)
				nbpoints=12;
			TrackProcess(Trackmode);
			glutSetWindow(Handle_Tracking );
			glutPostRedisplay();
			glutSetWindow(Handle_Scanline);
			glutPostRedisplay();
			glutSetWindow(Handle_Redresse);
			glutPostRedisplay();
			break;
		/* Point trackes -1 */
		case '-':
			nbpoints--;
			TrackProcess(Trackmode);
			glutSetWindow(Handle_Tracking );
			glutPostRedisplay();
			glutSetWindow(Handle_Scanline);
			glutPostRedisplay();
			glutSetWindow(Handle_Redresse);
			glutPostRedisplay();
			break;
	}
#if 0
		/* Changement des paramtres */
		case 'p':
		case 'P':
			printf("Changement des parametres du tracker :\n");
			printf("--------------------------------------\n");
			printf("Initialisation:\n");
			printf("\tNiveau de qualite : %lf\n\t->",tracker.quality);
			scanf("%lf",&tracker.quality);
			printf("\n\tDistance minimum : %lf\n\t->",tracker.minDistance);
			scanf("%lf",&tracker.minDistance);
			printf("Suivi:\n");
			printf("Niveau pyramidal : %d\n\t->",tracker.level);
			scanf("%d",&tracker.level);
			printf("Nombre de point : %d\n\t",nbpoints);
			scanf("%d",&nbpoints);
			TrackProcess(Trackmode);
			glutPostRedisplay();
			break;
		/* Affichage du morphing */
		case 'm':
		case 'M':
			Morphmode = !Morphmode;
			glutSetWindow(Handle_Scanline);
			glutPostRedisplay();
		/* Calcul des scanlines */
		case 's':
		case 'S':
			ScanlineProcess(Morphmode);
			glutSetWindow(Handle_Scanline);
			glutPostRedisplay();
			glutSetWindow(Handle_Redresse);
			glutPostRedisplay();
			break;
		/* Fonction de test */
		case 'w':
			//test(image[LEFT0].img,image[RIGHT0].img);
			/* Rsoltion */
			r1 = cvCreateImage(cvSize(image[0].img->width*4,image[0].img->height*4),image[0].img->depth,image[0].img->nChannels);
			r2 = cvCreateImage(cvSize(image[0].img->width*4,image[0].img->height*4),image[0].img->depth,image[0].img->nChannels);
			//cvConvertScale(image[0].img,r,2,0);
			cvResize( image[0].img, r1, CV_INTER_NN );
			cvResize( image[0].img, r2, CV_INTER_LINEAR );
			/*
			  CV_INTER_NN - nearest-neigbor interpolation, 
			  CV_INTER_LINEAR - bilinear interpolation (used by default) 
			*/
			cvNamedWindow("scalenn",1);
			cvShowImage("scalenn",r1);
			cvNamedWindow("scalennil",1);
			cvShowImage("scalennil",r2);
			cvNamedWindow("nonscale",0);
			cvShowImage("nonscale",image[0].img);
			break;
		/* Normalisation des scanlines */
		case 'n':
		case 'N':
			ProcessNormalisation();
			break;
	}
#endif
}

void displayScanline(void)
{
	double zoomx,zoomy;
	glViewport(0,0,TailleXscan,TailleYscan);
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	/* Dfinition du monde */
	glOrtho(0,TailleXscan,0,TailleYscan,-5,5);	
	/* Initialisation du frame buffer */
	glClearColor(0,0,0.0,0);
	glClear (GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);


	zoomx = (TailleXscan/3)/((GLfloat )Width);
	zoomy = (TailleYscan)/((GLfloat )Height);

	displayImage(image[2].img,0,0,TailleXscan/3,TailleYscan,zoomx,zoomy,NULL,NULL,image[LEFT1].scanline,image[LEFT1].nbscanline*2);
	displayImage(image[3].img,TailleXscan*2/3,0,TailleXscan/3,TailleYscan,zoomx,zoomy,NULL,NULL,image[RIGHT1].scanline,image[RIGHT1].nbscanline*2);

#if 0
	/* Affichage des deux images aves les scanlines */
	displayImage(image[2].img,0,0,TailleXscan/3,TailleYscan,zoomx,zoomy,image[2].nbscanline*2,NULL,NULL,image[2].scanline);
	displayImage(image[3].img,TailleXscan*2/3,0,TailleXscan/3,TailleYscan,zoomx,zoomy,image[3].nbscanline*2,NULL,NULL,image[3].scanline);
	/* Affichage du morphing */
	displayImage(morph,TailleXscan/3,0,TailleXscan/3,TailleYscan,zoomx,zoomy,0,NULL,NULL,NULL);
#endif
	/* Rafraichissement du frame buffer */
	glutSwapBuffers();
}
void reshapeScanline(GLsizei w, GLsizei h )
{
	TailleXscan = w;
	TailleYscan = h;
	displayScanline();
}
void displayRedressement(void)
{
	double zoomx,zoomy;
	int y;
	glViewport(0,0,TailleXredr,TailleYredr);
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	/* Dfinition du monde */
	glOrtho(0,TailleXredr,0,TailleYredr,-5,5);	
	/* Initialisation du frame buffer */
	glClearColor(0,0,0.0,0);
	glClear (GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);


	zoomx = (TailleXredr/3)/((GLfloat )Width);
	zoomy = (TailleYredr)/((GLfloat )Height);
	if(image[3].warped)
		zoomy = (TailleYredr)/((GLfloat )image[3].warped->height);

	displayImage(image[2].warped,0,0,TailleXredr/2,TailleYredr,zoomx,zoomy,0,NULL,NULL,0);
	displayImage(image[3].warped,TailleXredr/2,0,TailleXredr/2,TailleYredr,zoomx,zoomy,0,NULL,NULL,0);

	glColor3f(1,0,0);
	y = (-mouse_scany + TailleYredr);
	glBegin(GL_LINES);
		glVertex2f(0,y);
		glVertex2f(TailleXredr,y);
	glEnd();

	/* Rafraichissement du frame buffer */
	glutSwapBuffers();
}
void reshapeRedressement(GLsizei w, GLsizei h )
{
	TailleXredr = w;
	TailleYredr = h;
	displayRedressement();
}
void mousePassiveMotionRedre(int x,int y)
{
	mouse_scanx=x;
	mouse_scany=y;
	glutPostRedisplay();
}
